﻿using System;
using System.Threading;

namespace TickTockLib
{
    public class TickTock
    {
        public delegate void TickTockEventHandler(object sender, TickTockEventArgs e);
        public event TickTockEventHandler TickEvent; //event of tick
        public SynchronizationContext Context { get; set; }
        public class TickTockEventArgs : EventArgs
        {
            public int TickCounter { get; set; }
            public bool IsEndless;
            public SynchronizationContext Context { get; set; } //for 4 example Synchronization context
        }
        private int count = 10;

        public Thread TickTockThread { get; }

        public TickTock(int count)
        {
            this.count = count;
            TickTockThread = new Thread(Ticker);
        }

        public TickTock(int count, SynchronizationContext context) //new constructor with sychnronization context
        {
            this.count = count;
            TickTockThread = new Thread(Ticker);
            Context = context;
        }

        public void Join()
        {
            TickTockThread.Join();
        }

        public void Start()
        {
            TickTockThread.Start(count);
        }


        private void Ticker(object o)
        {
            int howMany = 0;
            if (o != null) howMany = (int)o;
            TickTockEventArgs tta = new TickTockEventArgs();
            tta.IsEndless = true;
            tta.Context = Context;
            if (howMany == 0)
            {
                tta.IsEndless = true;
                int ii = 0;
                while (true)
                {
                    tta.TickCounter = ii++;
                    if (TickEvent != null) TickEvent(this, tta);
                    Thread.Sleep(1000);
                }
            }
            else
            {
                tta.IsEndless = false;
                for (int ii = 0; ii < howMany; ii++)
                {
                    tta.TickCounter = ii;
                    if (TickEvent != null) TickEvent(this, tta);
                    Thread.Sleep(1000);
                }
            }
        }
    }
}
