﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using TickTockLib;

namespace TickTockWinForms
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private TickTock tickTock = null;
        
        private void Form1_Load(object sender, EventArgs e)
        {
            tickTock = new TickTock(20);
        }

        private void StartButton_Click(object sender, EventArgs e)
        {
            CounterLabel.Text = "0";
            labelSafe.Text = "0";
            tickTock = new TickTock(20);
            //version 4
            //tickTock = new TickTock(20,SynchronizationContext.Current);
            tickTock.TickEvent += TickTock_TickEvent;
            tickTock.Start();
            MessageBox.Show("Tick Tock started....");
        }

        delegate void SetCounterDelegate(string txt);
        private void SetCounterMethod(string txt)
        {
            CounterLabel.Text = txt;
        }

        /// <summary>
        /// The first example. Unsafe call
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TickTock_TickEvent(object sender, TickTock.TickTockEventArgs e)
        {
            CounterLabel.Text = e.TickCounter.ToString();
           
        }

        // The second example. Call delegate
        //private void TickTock_TickEvent(object sender, TickTock.TickTockEventArgs e)
        //{
        //    SetCounterDelegate setCounterDelegate = new SetCounterDelegate(SetCounterMethod);
        //    if (this.CounterLabel.InvokeRequired)
        //    {
        //        CounterLabel.Invoke(setCounterDelegate, new object[] { e.TickCounter.ToString() });
        //    }
        //    else
        //    {
        //        CounterLabel.Text = e.TickCounter.ToString();
        //    }
        //}

        /// The third version. With safe static class method
        //private void TickTock_TickEvent(object sender, TickTock.TickTockEventArgs e)
        //{
        //    ThreadSafeCalls.SetLabel(CounterLabel, e.TickCounter.ToString());
        //    //CounterLabel.Text = e.TickCounter.ToString();
        //}

        /// The fourth example Synchronization Context
        /// <summary>
        /// Function calls by synchronization context
        /// </summary>
        /// <param name="param"></param>
        //private void updateUI(object param)
        //{
        //    CounterLabel.Text = param as string;
        //}
        //private void TickTock_TickEvent(object sender, TickTock.TickTockEventArgs e)
        //{
        //    e.Context.Send(updateUI, e.TickCounter.ToString());
        //}


    }
}
